
//Browser Support Code
function SimpleAjax(name, myevent, id, value, outputid) 
{
    var genericRequest = new ajaxObject(ScriptUrl, genericCallback, myevent, outputid);
    params = getFormVals(myevent, name, id, value, true); // later need to parameterize arg here
    //alert("params="+params);
    genericRequest.update(params);
}

function genericCallback(responseText, responseStatus, responseXML, myevent, outputid)
{
    //alert("DEBUG: genericCallback: Text="+responseText+", Status="+responseStatus+", XML="+responseXML+", outputid="+outputid);
    if (responseStatus == 200) {
//var cType = this.getResponseHeader("Content-Type");
//alert("cType="+cType);
//for (var i in ajaxRequest) { alert(i+": "+ajaxRequest[i]); }
        if (responseXML == null) {
            if (outputid == "") { outputid = "output"; }
//alert("event="+myevent+", out="+outputid);
//alert("responseText="+responseText);
            document.getElementById(outputid).innerHTML = responseText;
        } else {
            values = responseXML.getElementsByTagName("value");
            for (var i=0; i < values.length; i++) {
                //alert(i+" of "+values.length+": attributes="+ values[i].attributes+", length="+values[i].attributes.length);
                id = values[i].attributes.getNamedItem("id").nodeValue;
                if (values[i].childNodes[0] == null) { text = ''; }
                else { text = values[i].childNodes[0].nodeValue; }
                //alert("id="+id+", text="+text);
                document.getElementById(id).value = text;
            }
            shows = responseXML.getElementsByTagName("show");
            for (var i=0; i < shows.length; i++) {
                x = document.getElementById(id);
                if (x != null) {
                    id = shows[i].getElementsByTagName("id")[0].childNodes[0].nodeValue;
                    text = shows[i].getElementsByTagName("text")[0].childNodes[0].nodeValue;
                    x.innerHTML = text;
                }
            }
            setvals = responseXML.getElementsByTagName("setval");
            for (var i=0; i < setvals.length; i++) {
                //alert(i);
                id = setvals[i].getElementsByTagName("id")[0].childNodes[0].nodeValue;
                x = setvals[i].getElementsByTagName("val");
                //alert("length="+x.length);
                if (x.length < 1) {
                    x = setvals[i].getElementsByTagName("value");
                }
                val = x[0].childNodes[0].nodeValue;
                //alert(val);
                document.getElementById(id).value = val;
            }
        }
        return(true);
    }
   //  else if (readyState > 0) {
      
   //   document.getElementById(outputid).innerHTML = "Searching...";
    
   //   return(true);
  
   //}
}

function SimpleAjax_preobject(scripturl, pagename, section, value, outputid) 
{
	var ajaxRequest;  // The variable that makes Ajax possible!
	
	try{
		// Opera 8.0+, Firefox, Safari
		ajaxRequest = new XMLHttpRequest();
	} catch (e){
		// Internet Explorer Browsers
		try{
			ajaxRequest = new ActiveXObject("Msxml2.XMLHTTP");
		} catch (e) {
			try{
				ajaxRequest = new ActiveXObject("Microsoft.XMLHTTP");
			} catch (e){
				// Something went wrong
				alert("Your browser broke!");
				return false;
			}
		}
	}
	// Create a function that will receive data sent from the server
	ajaxRequest.onreadystatechange = function(){
		if(ajaxRequest.readyState == 4 && ajaxRequest.status == 200){
//var cType = this.getResponseHeader("Content-Type");
//alert("cType="+cType);
//for (var i in ajaxRequest) { alert(i+": "+ajaxRequest[i]); }
			xmlDoc=ajaxRequest.responseXML;
            if (xmlDoc != null) {
                values = xmlDoc.getElementsByTagName("value");
                for (var i=0; i < values.length; i++) {
                    //alert(i+": attributes="+ values[i].attributes+", length="+values[i].attributes.length);
                    id = values[i].attributes.getNamedItem("id").nodeValue;
                    text = values[i].childNodes[0].nodeValue;
                    //alert("id="+id+", text="+text);
                    document.getElementById(id).value = text;
                }
                shows = xmlDoc.getElementsByTagName("show");
                for (var i=0; i < shows.length; i++) {
                    id = shows[i].getElementsByTagName("id")[0].childNodes[0].nodeValue;
                    text = shows[i].getElementsByTagName("text")[0].childNodes[0].nodeValue;
                    document.getElementById(id).innerHTML = text;
                }
                setvals = xmlDoc.getElementsByTagName("setval");
                for (var i=0; i < setvals.length; i++) {
                    //alert(i);
                    id = setvals[i].getElementsByTagName("id")[0].childNodes[0].nodeValue;
                    x = setvals[i].getElementsByTagName("val");
                    //alert("length="+x.length);
                    if (x.length < 1) {
                        x = setvals[i].getElementsByTagName("value");
                    }
                    val = x[0].childNodes[0].nodeValue;
                    //alert(val);
                    document.getElementById(id).value = val;
                }
            }
            document.getElementById(outputid).innerHTML = ajaxRequest.responseText;
			return(true);
		} else if (ajaxRequest.readyState > 0) {
			document.getElementById(outputid).innerHTML = "Searching...";
			return(true);
		}
	}
	//alert('value='+value); 
    request = getFormVals(pagename, section, true); // later need to parameterize arg here
    //alert("request="+request);
    ajaxRequest.open("GET", scripturl+"/"+pagename+request, true);
    //ajaxRequest.setRequestHeader('Content-Type',  "text/xml");
    //ajaxRequest.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
    //ajaxRequest.setRequestHeader("Content-length", request.length);
    //ajaxRequest.setRequestHeader("Connection", "close");
	ajaxRequest.send(null); 
}

function getFormVals(myevent, name, id, value, form)
{
    // walk all forms, putting them in XML to pass via POST
    // (this is not efficient, but it makes it easier for developers)
    var request = "";
    //alert("foo="+foo+", page="+SimpleAjaxScript[foo]);
    if (SimpleAjaxScript[name]) {
        field = name;
    } else {
        field = 'page';
    }
    if (SimpleAjaxScript[field][myevent]) {
        pagename = SimpleAjaxScript[field][myevent]; 
    } else {
        pagename = SimpleAjaxScript[field]["*"]; 
    }
    if (SimpleAjaxSection[field][myevent]) {
        section = SimpleAjaxSection[field][myevent];
    } else {
        section = SimpleAjaxSection[field]["*"];
    }
    request = "?n="+pagename+"&action=simpleajax&section="+section;
    request += "&"+SimpleAjaxPrefix+"name="+name+"&"+SimpleAjaxPrefix+"val="+value+"&"+SimpleAjaxPrefix+"id="+id;
    //alert("field="+field+", pagename="+pagename+", section="+section+", request="+request);
    if (form) {
        // 
        // EVERYTHING BELOW WAS TO MAKE NICE XML $_POST SUBMISSION BUT IT ISN"T
        // WORKING AND I"M TIRED AND THEY TELL ME I SHOULD USE $_GET ANYWAY SO
        // I"M GIVING UP AND GOING BACK TO $_GET EVEN FOR FORM SUBMISSION
        //
        //var request = "<forms>";
        //for (var f=0; f < document.forms.length; f++) {
            //var curform = document.forms[f];
            //request += "<form name="+curform.getAttribute("name")+" id="+curform.getAttribute("id")+">";
            //for (var flds=0; flds < curform.elements.length; flds++) {
                //curfld = curform.elements[flds];
                //request += "<field name="+curfld.getAttribute("name")+" id="+curfld.getAttribute("id")+">";
                //request += curfld.value;
                //request += "</field>";
            //}
            //request += "</form>";
        //}
        //request += "</forms>";
        //ajaxRequest.open("POST", scripturl+"/"+pagename, true);
        for (var f=0; f < document.forms.length; f++) {
            var curform = document.forms[f];
            //request += "<form name="+curform.getAttribute("name")+" id="+curform.getAttribute("id")+">";
            for (var flds=0; flds < curform.elements.length; flds++) {
                curfld = curform.elements[flds];
                var fldname = curfld.getAttribute("name");
                if (fldname != null && fldname != "action" && fldname != "q" && fldname != "n" && curfld.value != null) {
                    request += "&"+curfld.getAttribute("name")+"="+encodeURIComponent(curfld.value);
                }
            }
        }
    }
    return(request);
}

function a_message() 
{ 
alert('I came from an external script! Ha, Ha, Ha!!!!'); 
}

// Although www.hunlock.com/blogs/The_Ultimate_Ajax_Object explicitly releases
// from the need of giving credit ... it just seems wrong, so here's the credit.
function ajaxObject(url, callbackFunction, myevent, outputid) {
  var that=this;      
  this.updating = false;
  this.abort = function() {
    if (that.updating) {
      that.updating=false;
      that.AJAX.abort();
      that.AJAX=null;
    }
  }
  this.update = function(passData,postMethod) { 
    if (that.updating) { return false; }
    that.AJAX = null;                          
    if (window.XMLHttpRequest) {              
      that.AJAX=new XMLHttpRequest();              
    } else {                                  
      that.AJAX=new ActiveXObject("Microsoft.XMLHTTP");
    }                                             
    if (that.AJAX==null) {                             
      return false;                               
    } else {
      that.AJAX.onreadystatechange = function() {  
        if (that.AJAX.readyState==4) {             
          that.updating=false;                
          that.callback(that.AJAX.responseText,that.AJAX.status,that.AJAX.responseXML, myevent, outputid);
          that.AJAX=null;                                         
        }                                                      
      }                                                        
      that.updating = new Date();                              
      if (/post/i.test(postMethod)) {
        var uri=urlCall+'?'+that.updating.getTime();
        that.AJAX.open("POST", uri, true);
        that.AJAX.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
        that.AJAX.setRequestHeader("Content-Length", passData.length);
        that.AJAX.send(passData);
      } else {
        var uri=urlCall+'?'+passData+'&timestamp='+(that.updating.getTime()); 
        that.AJAX.open("GET", uri, true);                             
        that.AJAX.send(null);                                         
      }              
      return true;                                             
    }                                                                           
  }
  var urlCall = url;        
  this.callback = callbackFunction || function () { };
}

